#include "LuaDebugDLL.h"

lua_State   *ls = NULL;

void GetGlobal(const char *varName)
{
    lua_getglobal(ls, varName);
    lua_pop(ls, 1);
}

void LuaHook(lua_State *state, lua_Debug *debug)
{
    lua_getinfo(state, "S", debug);
    lua_getinfo(state, "n", debug);

    ls = state;

    // try to get the values of some global variables that do not exist
    GetGlobal("::dummyVar1");
    GetGlobal("::dummyVar2");
    GetGlobal("::dummyVar3");
    GetGlobal("::dummyVar4");

    return;
}


//////////////////////////////////////////////////////////////////////////
/// exported functions
//////////////////////////////////////////////////////////////////////////

int InitDebugger(lua_State *poLUAState)
{
    lua_sethook(poLUAState, LuaHook, LUA_MASKLINE | LUA_MASKCALL | LUA_MASKRET, 0);
    return 1;
}

