// TestLUA.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

extern "C"
{
	#include <LUA/lua.h>
	#include <LUA/lualib.h>
	#include <LUA/lauxlib.h>
}

#include <windows.h>

#pragma comment(lib, "LuaLib.lib" )

lua_State *ls;

#include "../Tools/Lua/LuaDLL/LuaDebugDLL.h"

#ifdef _DEBUG
    #pragma comment(lib, "../Output/Bin_D/LuaDLL_D.lib")
#else
    #pragma comment(lib, "../Output/Bin/LuaDLL.lib")
#endif

int ExecScript(lua_State *ls)
{
    const char *script = lua_tostring(ls, -1);
    lua_dofile(ls, script);
    return 1;
}

int __cdecl _tmain(int argc, _TCHAR* argv[])
{
	ls = lua_open();
	if (!ls)
	{
		printf("Unable to open lua state\n");
		return 0;
	}

	lua_baselibopen(ls);
	luaopen_table(ls);
	lua_iolibopen(ls);
	lua_strlibopen(ls);
    lua_mathlibopen(ls);

#ifdef _DEBUG
    InitDebugger(ls);
#endif

	printf("lua opened successfully, closing\n");

    lua_pushcfunction(ls, ExecScript);
    lua_setglobal(ls, "ExecScript");

    // stress scenario, but it rarely gets above 2 iterations (infact it never
    // does in the current scenario)
    for (int i = 0; i < 10000; i++)
        lua_dofile(ls, "Test\\Test.l");

	lua_close(ls);

	return 0;
}

